from qgis.gui import *
from PyQt4.QtGui import QAction, QMainWindow
from PyQt4.QtCore import SIGNAL, Qt, QString
from qgis.core import *
from postgisbboxdialog import PostgisBBoxDialog
import postgis_utils
from ui_postgisbbox import Ui_PostgisBBox

class MyWnd(QMainWindow):
  def __init__(self, layer,ext):
    QMainWindow.__init__(self)
    
   
    self.canvas = QgsMapCanvas()
    self.canvas.setCanvasColor(Qt.white)
    if not layer.isValid():
        raise IOError, "Failed to open the layer"
    else:
    # add layer to the registry
        QgsMapLayerRegistry.instance().addMapLayer(layer, False)
        
    
    
    

    #self.canvas.setExtent(layer.extent())
    self.canvas.setExtent(ext)
    
    self.canvas.setLayerSet( [ QgsMapCanvasLayer(layer) ] )
    
    
   

    self.setCentralWidget(self.canvas)
    
     
    

    actionZoomIn = QAction(QString("Zoom in"), self)
    actionZoomOut = QAction(QString("Zoom out"), self)
    actionPan = QAction(QString("Pan"), self)
   

    actionZoomIn.setCheckable(True)
    actionZoomOut.setCheckable(True)
    actionPan.setCheckable(True)
    

    self.connect(actionZoomIn, SIGNAL("triggered()"), self.zoomIn)
    self.connect(actionZoomOut, SIGNAL("triggered()"), self.zoomOut)
    self.connect(actionPan, SIGNAL("triggered()"), self.pan)
    
    #self.connect(self.canvas, SIGNAL("extentsChanged()"), self.zoomIn)
    self.toolbar = self.addToolBar("Canvas actions")
    self.toolbar.addAction(actionZoomIn)
    self.toolbar.addAction(actionZoomOut)
    self.toolbar.addAction(actionPan)
 


    # create the map tools
    self.toolPan = QgsMapToolPan(self.canvas)
    self.toolPan.setAction(actionPan)
    self.toolZoomIn = QgsMapToolZoom(self.canvas, False) # false = in
    self.toolZoomIn.setAction(actionZoomIn)
    self.toolZoomOut = QgsMapToolZoom(self.canvas, True) # true = out
    self.toolZoomOut.setAction(actionZoomOut)
 

    self.pan()
    
  
      
      
  def zoomIn(self):
    
        self.canvas.setMapTool(self.toolZoomIn)
    
    
  def xmin(self):
        coordinate = self.canvas.extent()
        xmin = coordinate.xMinimum()
        
        return xmin
    
  def xmax(self):
        coordinate = self.canvas.extent()
        xmax = coordinate.xMaximum()
        
        return xmax
    
  def ymin(self):
        coordinate = self.canvas.extent()
        ymin = coordinate.yMinimum()
        
        return ymin
    
  def ymax(self):
        coordinate = self.canvas.extent()
        ymax = coordinate.yMaximum()
        
        return ymax    

  
      
  def zoomOut(self):
    self.canvas.setMapTool(self.toolZoomOut)
    

  def pan(self):
    self.canvas.setMapTool(self.toolPan)
    